## load table
readith <- read.csv(file="no_timeouts.csv", head=TRUE, sep=",");
library(ggplot2)

## RULES

## errors according to rule
errorsR <- aggregate(EAny ~ CRule, readith, sum);

## all according to rule
allR <- aggregate(EAny ~ CRule, readith, length);

noErrR <- allR$EAny - errorsR$EAny

errorsR$noErr <- noErrR
names(errorsR)[names(errorsR)=="EAny"] <- "Err"
errorMatR <- data.matrix(errorsR[2:3])
dimnames(errorMatR) =list(errorsR$CRule, c("Err", "noErr"))
resultAllR <- chisq.test(errorMatR)

## compare Combine and Copy Contour
errCOCC <- errorsR[errorsR["CRule"] == "Combine"| errorsR["CRule"]=="Copy Contour",]
errCOCCMat <- data.matrix(errCOCC[2:3])
dimnames(errCOCCMat) =list(errCOCC$CRule, c("Err", "noErr"))
resultCOCC <- chisq.test(errCOCCMat)

## compare Combine and Copy Shading
errCOCS <- errorsR[errorsR["CRule"] == "Combine"| errorsR["CRule"]=="Copy Shading",]
errCOCSMat <- data.matrix(errCOCS[2:3])
dimnames(errCOCSMat) =list(errCOCS$CRule, c("Err", "noErr"))
resultCOCS <- chisq.test(errCOCSMat)

## compare Combine and Erase Contour
errCOEC <- errorsR[errorsR["CRule"] == "Combine"| errorsR["CRule"]=="Erase Contour",]
errCOECMat <- data.matrix(errCOEC[2:3])
dimnames(errCOECMat) =list(errCOEC$CRule, c("Err", "noErr"))
resultCOEC <- chisq.test(errCOECMat)

## compare Combine and Erase Shading
errCOES <- errorsR[errorsR["CRule"] == "Combine"| errorsR["CRule"]=="Erase Shading",]
errCOESMat <- data.matrix(errCOES[2:3])
dimnames(errCOESMat) =list(errCOES$CRule, c("Err", "noErr"))
resultCOES <- chisq.test(errCOESMat)

## compare Copy Contour and Copy Shading
errCCCS <- errorsR[errorsR["CRule"] == "Copy Contour"| errorsR["CRule"]=="Copy Shading",]
errCCCSMat <- data.matrix(errCCCS[2:3])
dimnames(errCCCSMat) =list(errCCCS$CRule, c("Err", "noErr"))
resultCCCS <- chisq.test(errCCCSMat)

## compare Copy Contour and Erase Contour
errCCEC <- errorsR[errorsR["CRule"] == "Copy Contour"| errorsR["CRule"]=="Erase Contour",]
errCCECMat <- data.matrix(errCCEC[2:3])
dimnames(errCCECMat) =list(errCCEC$CRule, c("Err", "noErr"))
resultCCEC <- chisq.test(errCCECMat)

## compare Copy Contour and Erase Shading
errCCES <- errorsR[errorsR["CRule"] == "Copy Contour"| errorsR["CRule"]=="Erase Shading",]
errCCESMat <- data.matrix(errCCES[2:3])
dimnames(errCCESMat) =list(errCCES$CRule, c("Err", "noErr"))
resultCCES <- chisq.test(errCCESMat)

## compare Copy Shading and Erase Contour
errCSEC <- errorsR[errorsR["CRule"] == "Copy Shading"| errorsR["CRule"]=="Erase Contour",]
errCSECMat <- data.matrix(errCSEC[2:3])
dimnames(errCSECMat) =list(errCSEC$CRule, c("Err", "noErr"))
resultCSEC <- chisq.test(errCSECMat)

## compare Copy Shading and Erase Shading
errCSES <- errorsR[errorsR["CRule"] == "Copy Shading"| errorsR["CRule"]=="Erase Shading",]
errCSESMat <- data.matrix(errCSES[2:3])
dimnames(errCSESMat) =list(errCSES$CRule, c("Err", "noErr"))
resultCSES <- chisq.test(errCSESMat)

## compare Erase Contour and Erase Shading
errECES <- errorsR[errorsR["CRule"] == "Erase Contour"| errorsR["CRule"]=="Erase Shading",]
errECESMat <- data.matrix(errECES[2:3])
dimnames(errECESMat) =list(errECES$CRule, c("Err", "noErr"))
resultECES <- chisq.test(errECESMat)


## CLUTTER

errorsC <- aggregate(EAny ~ Clutter, readith, sum);
## all according to clutter
allC <- aggregate(EAny ~ Clutter, readith, length);

noErrC <- allC$EAny - errorsC$EAny

errorsC$noErr <- noErrC
names(errorsC)[names(errorsC)=="EAny"] <- "Err"
errorMatC <- data.matrix(errorsC[2:3])
dimnames(errorMatC) =list(errorsC$Clutter, c("Err", "noErr"))
resultAllC <- chisq.test(errorMatC)



## Errors per rule and Clutter amount
##errorsRC <- aggregate(EAny ~ (CRule:Clutter), readith, sum)
## all according to rule and Clutter
##allRC <- aggregate(EAny ~ CRule:Clutter, readith, length);
##noErrRC <- allRC$EAny - errorsRC$EAny
##errorsRC$noErr <- noErrRC
##names(errorsRC)[names(errorsRC)=="EAny"] <- "Err"
##errorsRCMat <- data.matrix(errorsRC[3:4])
##dimnames(errorsRCMat) =list(paste(errorsRC$CRule,errorsRC$Clutter,sep=""),  c("Err", "noErr"))
##resultRC <- chisq.test(errorsRCMat)
##interactRC <- ggplot(errorsRC, aes(x=Clutter, y=EAny, colour=CRule, shape=CRule))+
##    scale_x_discrete("Amount of Clutter")+
##    scale_y_continuous("Amount of Errors")+    
##     theme_bw()+
##    geom_point()+
##        geom_line(data =errorsRC, aes(y = EAny, group = CRule))+
## scale_color_hue(c=300, l=30)
##interact2 <- ggplot(errorsRC, aes(x=CRule, y=EAny, colour=Clutter, shape=Clutter))+
##    scale_x_discrete("Type of Rule")+
##    scale_y_continuous("Amount of Errors")+    
##     theme_bw()+
##    geom_point()+
##        geom_line(data =errorsRC, aes(y = EAny, group = Clutter))+
## scale_color_hue(c=300, l=30)
## print(interact2)

## errors per Question
errorsQ <- aggregate(EAny ~ QRef, readith, sum);

## errors per participant
errorsP <- aggregate(EAny ~ PRef, readith, sum);

## removing errors of outliers (Participant 3 and 25)

readith2 <- readith[!((readith["PRef"] == 3 & readith["EAny"] == 1) | (readith["PRef"] == 25 & readith["EAny"] == 1)),]
outlierErrors <- readith[((readith["PRef"] == 3 & readith["EAny"] == 1) | (readith["PRef"] == 25 & readith["EAny"] == 1)),]

errorsC2 <- aggregate(EAny ~ Clutter, readith2, sum);
## all according to clutter
allC2 <- aggregate(EAny ~ Clutter, readith2, length);

noErrC2 <- allC2$EAny - errorsC2$EAny

errorsC2$noErr <- noErrC2
names(errorsC2)[names(errorsC2)=="EAny"] <- "Err"
errorMatC2 <- data.matrix(errorsC2[2:3])
dimnames(errorMatC2) =list(errorsC2$Clutter, c("Err", "noErr"))
resultAllC2 <- chisq.test(errorMatC2)




##barplot(errorsQ$EAny, ylab="Errors", xlab="Question", names.arg=errorsQ$QRef)+ 


######################################################
##
## Output results to file errors.txt
##
######################################################

sink("errors.txt")
cat("Errors according to Clutter\n")
cat("===========================\n")
print(errorMatC)
print(resultAllC)

cat("\n\n")
cat("Errors according to Rules\n")
cat("===========================\n")
print(errorMatR)
print(resultAllR)

cat("\n")
cat("Combine vs. Copy Contour\n")
cat("===========================\n")
print(resultCOCC) 

cat("\n")
cat("Combine vs. Copy Shading\n")
cat("===========================\n")
print(resultCOCS) 

cat("\n")
cat("Combine vs. Erase Contour\n")
cat("===========================\n")
print(resultCOEC) 

cat("\n")
cat("Combine vs. Erase Shading\n")
cat("===========================\n")
print(resultCOES) 

cat("\n")
cat("Copy Contour vs. Copy Shading\n")
cat("===========================\n")
print(resultCCCS) 

cat("\n")
cat("Copy Contour vs. Erase Contour\n")
cat("===========================\n")
print(resultCCEC) 

cat("\n")
cat("Copy Contour vs. Erase Shading\n")
cat("===========================\n")
print(resultCCES) 

cat("\n")
cat("Copy Shading vs. Erase Contour\n")
cat("===========================\n")
print(resultCSEC) 

cat("\n")
cat("Copy Shading vs. Erase Shading\n")
cat("===========================\n")
print(resultCSES) 

cat("\n")
cat("Erase Contour vs. Erase Shading\n")
cat("===========================\n")
print(resultECES) 

sink()


###############################################
## Output plots
###############################################


pdf("errorsQ.pdf", useDingbats=FALSE)
                     
errorBarQ <- ggplot(errorsQ, aes(x=QRef, y=EAny))+
    scale_x_discrete("Question", limits=errorsQ$QRef)+
    scale_y_continuous("Amount of Errors")+    
        theme_bw()+
           geom_bar( stat="identity")+ 
 scale_color_hue(c=300, l=30)
 print(errorBarQ)
dev.off()

pdf("errorsP.pdf", useDingbats=FALSE)
                     
errorBarP <- ggplot(errorsP, aes(x=PRef, y=EAny))+
    scale_x_discrete("Participant", limits=errorsP$PRef)+
    scale_y_discrete("Amount of Errors")+    
        theme_bw()+
           geom_bar( stat="identity")+ 
 scale_color_hue(c=300, l=30)
 print(errorBarP)
dev.off()
